package de.fraunhofer.iem.dataprovider.gitlab.controller

import de.fraunhofer.iem.dataprovider.configuration.ApiPaths
import de.fraunhofer.iem.dataprovider.gitlab.dto.RepositoryChangedDto
import de.fraunhofer.iem.dataprovider.gitlab.enumeration.PlatformEnum
import de.fraunhofer.iem.dataprovider.gitlab.service.GitlabService
import de.fraunhofer.iem.dataprovider.logger.getLogger
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController


@RestController
@RequestMapping(ApiPaths.GITLAB)
class GitlabController(private val gitlabService: GitlabService) {

    private val logger = getLogger(javaClass)

    // TODO: if the parsing of the request body fails we send a stack
    //  trace back this should be changed to a custom error.
    @PostMapping(ApiPaths.GITLAB_REPO_CHANGED)
    suspend fun repoChanged(@RequestBody repositoryChangedDto: RepositoryChangedDto) {
        logger.info("Repo changed POST request for ID ${repositoryChangedDto.repoId} on platform ${repositoryChangedDto.platform} received.")
        when (repositoryChangedDto.platform) {
            PlatformEnum.OPEN_CODE -> gitlabService.queryOpenCodeProject(repositoryChangedDto.repoId)
        }
    }

}